"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var shared_1 = require("@formily/shared");
var context_1 = require("../context");
exports.useComponent = function (name) {
    var components = react_1.useContext(context_1.ArrayContext).components;
    return react_1.useMemo(function () {
        if (shared_1.isFn(components[name]) || components[name].styledComponentId)
            return components[name];
        return function (props) {
            return react_1.default.isValidElement(components[name]) ? (react_1.default.cloneElement(components[name], props)) : (react_1.default.createElement(react_1.Fragment, null));
        };
    }, []);
};
